Package org.apache.commons.io.output

# Class AbstractByteArrayOutputStream<T extends AbstractByteArrayOutputStream<T>>

java.lang.Object
java.io.OutputStream
org.apache.commons.io.output.AbstractByteArrayOutputStream<T>

Type Parameters:
  `T` - The AbstractByteArrayOutputStream subclass

All Implemented Interfaces:
  `Closeable`, `Flushable`, `AutoCloseable`

Direct Known Subclasses:
  `ByteArrayOutputStream`, `UnsynchronizedByteArrayOutputStream`

public abstract class AbstractByteArrayOutputStream<T extends AbstractByteArrayOutputStream<T>> extends OutputStream
This is the base class for implementing an output stream in which the data is written into a byte array. The buffer automatically grows as data is written to it.

The data can be retrieved using `toByteArray()` and `toString()`. Closing an `AbstractByteArrayOutputStream` has no effect. The methods in this class can be called after the stream has been closed without generating an `IOException`.

This is the base for an alternative implementation of the `ByteArrayOutputStream` class. The original implementation only allocates 32 bytes at the beginning. As this class is designed for heavy duty it starts at 1024 bytes. In contrast to the original it doesn't reallocate the whole memory block but allocates additional buffers. This way no buffers need to be garbage collected and the contents don't have to be copied to the new buffer. This class is designed to behave exactly like the original. The only exception is the deprecated `ByteArrayOutputStream.toString(int)` method that has been ignored.

Since:
  2.7

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `protected static interface`
  `AbstractByteArrayOutputStream.InputStreamConstructor<T extends InputStream>`
  Constructor for an InputStream subclass.

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected int`
  `count`
  The total count of bytes written.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `AbstractByteArrayOutputStream()`
  Constructs a new instance for subclasses.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `protected T`
  `asThis()`
  Returns this instance typed to `T`.
  `void`
  `close()`
  Does nothing.
  `protected void`
  `needNewBuffer(int newCount)`
  Makes a new buffer available either by allocating a new one or re-cycling an existing one.
  `abstract void`
  `reset()`
  See `ByteArrayOutputStream.reset()`.
  `protected void`
  `resetImpl()`
  Implements a default reset behavior.
  `abstract int`
  `size()`
  Returns the current size of the byte array.
  `abstract byte[]`
  `toByteArray()`
  Gets the current contents of this byte stream as a byte array.
  `protected byte[]`
  `toByteArrayImpl()`
  Gets the current contents of this byte stream as a byte array.
  `abstract InputStream`
  `toInputStream()`
  Gets the current contents of this byte stream as an Input Stream.
  `protected <T extends InputStream>
  InputStream`
  `toInputStream(AbstractByteArrayOutputStream.InputStreamConstructor<T> isConstructor)`
  Gets the current contents of this byte stream as an Input Stream.
  `String`
  `toString()`
  Deprecated.
  Use `toString(String)` instead
  `String`
  `toString(String enc)`
  Gets the current contents of this byte stream as a string using the specified encoding.
  `String`
  `toString(Charset charset)`
  Gets the current contents of this byte stream as a string using the specified encoding.
  `void`
  `write(byte[] b)`
  Writes `b.length` bytes from the given byte array to this output stream.
  `abstract void`
  `write(byte[] b, int off, int len)`
  `abstract void`
  `write(int b)`
  `abstract int`
  `write(InputStream in)`
  Writes the entire contents of the specified input stream to this byte stream.
  `T`
  `write(CharSequence data, Charset charset)`
  Writes the bytes for given CharSequence encoded using a Charset.
  `protected void`
  `writeImpl(byte[] b, int off, int len)`
  Writes the bytes to the byte array.
  `protected void`
  `writeImpl(int b)`
  Writes a byte to byte array.
  `protected int`
  `writeImpl(InputStream in)`
  Writes the entire contents of the specified input stream to this byte stream.
  `abstract void`
  `writeTo(OutputStream out)`
  Writes the entire contents of this byte stream to the specified output stream.
  `protected void`
  `writeToImpl(OutputStream out)`
  Writes the entire contents of this byte stream to the specified output stream.

  ### Methods inherited from class java.io.OutputStream

  `flush`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Field Details

  - ### count

    protected int count
    The total count of bytes written.

- ## Constructor Details

  - ### AbstractByteArrayOutputStream

    public AbstractByteArrayOutputStream()
    Constructs a new instance for subclasses.

- ## Method Details

  - ### asThis

    protected T asThis()
    Returns this instance typed to `T`.
    Returns:
      this instance

  - ### close

    public void close() throws IOException
    Does nothing. The methods in this class can be called after the stream has been closed without generating an `IOException`.
    Specified by:
      `close` in interface `AutoCloseable`
    Specified by:
      `close` in interface `Closeable`
    Overrides:
      `close` in class `OutputStream`
    Throws:
      `IOException` - never (this method should not declare this exception but it has to now due to backwards compatibility)

  - ### needNewBuffer

    protected void needNewBuffer(int newCount)
    Makes a new buffer available either by allocating a new one or re-cycling an existing one.
    Parameters:
      `newCount` - the size of the buffer if one is created

  - ### reset

    public abstract void reset()
    See `ByteArrayOutputStream.reset()`.
    See Also:
      - `ByteArrayOutputStream.reset()`

  - ### resetImpl

    protected void resetImpl()
    Implements a default reset behavior.
    See Also:
      - `ByteArrayOutputStream.reset()`

  - ### size

    public abstract int size()
    Returns the current size of the byte array.
    Returns:
      the current size of the byte array

  - ### toByteArray

    public abstract byte[] toByteArray()
    Gets the current contents of this byte stream as a byte array. The result is independent of this stream.
    Returns:
      the current contents of this output stream, as a byte array
    See Also:
      - `ByteArrayOutputStream.toByteArray()`

  - ### toByteArrayImpl

    protected byte[] toByteArrayImpl()
    Gets the current contents of this byte stream as a byte array. The result is independent of this stream.
    Returns:
      the current contents of this output stream, as a byte array
    See Also:
      - `ByteArrayOutputStream.toByteArray()`

  - ### toInputStream

    public abstract InputStream toInputStream()
    Gets the current contents of this byte stream as an Input Stream. The returned stream is backed by buffers of `this` stream, avoiding memory allocation and copy, thus saving space and time.
    Returns:
      the current contents of this output stream.
    Since:
      2.5
    See Also:
      - `ByteArrayOutputStream.toByteArray()`
      - `reset()`

  - ### toInputStream

    protected <T extends InputStream> InputStream toInputStream(AbstractByteArrayOutputStream.InputStreamConstructor<T> isConstructor)
    Gets the current contents of this byte stream as an Input Stream. The returned stream is backed by buffers of `this` stream, avoiding memory allocation and copy, thus saving space and time.
    Type Parameters:
      `T` - the type of the InputStream which makes up the `SequenceInputStream`.
    Parameters:
      `isConstructor` - A constructor for an InputStream which makes up the `SequenceInputStream`.
    Returns:
      the current contents of this output stream.
    Since:
      2.7
    See Also:
      - `ByteArrayOutputStream.toByteArray()`
      - `reset()`

  - ### toString

    @Deprecated public String toString()
    Deprecated.
    Use `toString(String)` instead
    Gets the current contents of this byte stream as a string using the virtual machine's `default charset`.
    Overrides:
      `toString` in class `Object`
    Returns:
      the contents of the byte array as a String
    See Also:
      - `ByteArrayOutputStream.toString()`
      - `Charset.defaultCharset()`

  - ### toString

    public String toString(Charset charset)
    Gets the current contents of this byte stream as a string using the specified encoding.
    Parameters:
      `charset` - the character encoding
    Returns:
      the string converted from the byte array
    Since:
      2.5
    See Also:
      - `ByteArrayOutputStream.toString(String)`

  - ### toString

    public String toString(String enc) throws UnsupportedEncodingException
    Gets the current contents of this byte stream as a string using the specified encoding.
    Parameters:
      `enc` - the name of the character encoding
    Returns:
      the string converted from the byte array
    Throws:
      `UnsupportedEncodingException` - if the encoding is not supported
    See Also:
      - `ByteArrayOutputStream.toString(String)`

  - ### write

    public void write(byte[] b)
    Writes `b.length` bytes from the given byte array to this output stream. This has same effect as `write(b, 0, b.length)`.
    Overrides:
      `write` in class `OutputStream`
    Parameters:
      `b` - the data.
    Since:
      2.19.0
    See Also:
      - `write(byte[], int, int)`

  - ### write

    public abstract void write(byte[] b, int off, int len)
    Overrides:
      `write` in class `OutputStream`

  - ### write

    public T write(CharSequence data, Charset charset)
    Writes the bytes for given CharSequence encoded using a Charset.
    Parameters:
      `data` - The String to convert to bytes. not null.
      `charset` - The `Charset` o encode the `String`, null means the default encoding.
    Returns:
      this instance.
    Since:
      2.19.0

  - ### write

    public abstract int write(InputStream in) throws IOException
    Writes the entire contents of the specified input stream to this byte stream. Bytes from the input stream are read directly into the internal buffer of this stream.
    Parameters:
      `in` - the input stream to read from
    Returns:
      total number of bytes read from the input stream (and written to this stream)
    Throws:
      `IOException` - if an I/O error occurs while reading the input stream
    Since:
      1.4

  - ### write

    public abstract void write(int b)
    Specified by:
      `write` in class `OutputStream`

  - ### writeImpl

    protected void writeImpl(byte[] b, int off, int len)
    Writes the bytes to the byte array.
    Parameters:
      `b` - the bytes to write
      `off` - The start offset
      `len` - The number of bytes to write

  - ### writeImpl

    protected int writeImpl(InputStream in) throws IOException
    Writes the entire contents of the specified input stream to this byte stream. Bytes from the input stream are read directly into the internal buffer of this stream.
    Parameters:
      `in` - the input stream to read from
    Returns:
      total number of bytes read from the input stream (and written to this stream)
    Throws:
      `IOException` - if an I/O error occurs while reading the input stream
    Since:
      2.7

  - ### writeImpl

    protected void writeImpl(int b)
    Writes a byte to byte array.
    Parameters:
      `b` - the byte to write

  - ### writeTo

    public abstract void writeTo(OutputStream out) throws IOException
    Writes the entire contents of this byte stream to the specified output stream.
    Parameters:
      `out` - the output stream to write to
    Throws:
      `IOException` - if an I/O error occurs, such as if the stream is closed
    See Also:
      - `ByteArrayOutputStream.writeTo(OutputStream)`

  - ### writeToImpl

    protected void writeToImpl(OutputStream out) throws IOException
    Writes the entire contents of this byte stream to the specified output stream.
    Parameters:
      `out` - the output stream to write to
    Throws:
      `IOException` - if an I/O error occurs, such as if the stream is closed
    See Also:
      - `ByteArrayOutputStream.writeTo(OutputStream)`